"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var HttpProxyModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpProxyModule = void 0;
const common_1 = require("@nestjs/common");
const http_proxy_middleware_1 = require("http-proxy-middleware");
const http_proxy_constants_1 = require("./http-proxy.constants");
let HttpProxyModule = HttpProxyModule_1 = class HttpProxyModule {
    static forRoot(options) {
        const providers = [
            {
                provide: http_proxy_constants_1.HTTP_PROXY_OPTIONS,
                useValue: options,
            },
        ];
        return {
            module: HttpProxyModule_1,
            providers,
            exports: providers,
        };
    }
    static forRootAsync(options) {
        const providers = [
            ...this.createAsyncProviders(options),
        ];
        return {
            module: HttpProxyModule_1,
            imports: options.imports || [],
            providers,
            exports: providers,
        };
    }
    static createAsyncProviders(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        return [
            this.createAsyncOptionsProvider(options),
            {
                provide: options.useClass,
                useClass: options.useClass,
            },
        ];
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: http_proxy_constants_1.HTTP_PROXY_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            provide: http_proxy_constants_1.HTTP_PROXY_OPTIONS,
            useFactory: async (optionsFactory) => await optionsFactory.createHttpProxyOptions(),
            inject: [options.useExisting || options.useClass],
        };
    }
    constructor(options) {
        this.options = options;
    }
    configure(consumer) {
        const proxyTable = this.options;
        Object.keys(proxyTable).forEach((context) => {
            let options = proxyTable[context];
            if (typeof options === 'string') {
                options = { target: options, changeOrigin: true };
            }
            const httpProxy = (0, http_proxy_middleware_1.createProxyMiddleware)(options);
            consumer
                .apply(httpProxy)
                .forRoutes(context);
        });
    }
};
exports.HttpProxyModule = HttpProxyModule;
exports.HttpProxyModule = HttpProxyModule = HttpProxyModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({}),
    __param(0, (0, common_1.Inject)(http_proxy_constants_1.HTTP_PROXY_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], HttpProxyModule);
//# sourceMappingURL=http-proxy.module.js.map